/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include "interface.h"
#include "support.h"
#include "penguzilla.h"

button_group tastatur, toolbar;
gboolean load_uri;
gboolean keyboard1;
GtkWidget *windowTop, *combo_list, *URIlabel [15];
char *device_file_name;
int device_width;
gboolean toolbar_all;
gboolean toolbar_load;
gboolean URI_scrolled;
gboolean nogprs;
GtkList *URI_history;
gint URI_history_pos;
FILE *fhan;

pengu_iface connect_iface;

guint text_listener, focus_listener;

void gtk_set_mouse_position (GtkWidget *wid, int x, int y);

const char *settings [] = 
{
	"entry_setup_user", "entry_setup_url",
	"entry_setup_dns", "entry_setup_pin",
	"entry_setup_ipaddress", "entry_setup_netmask",
	"entry_setup_pass", "entry_setup_gateway", NULL
};

gdouble disp_speed (void)
{
	static gulong rxtx = 0;
	guint rx, tx, d;
	FILE *fhan;
	
	switch (connect_iface)
	{
	case PPP0:
		fhan = fopen ("/sys/class/net/ppp0/statistics/tx_bytes", "r");
		break;
	case ETH0:
		fhan = fopen ("/sys/class/net/eth0/statistics/tx_bytes", "r");
		break;
	}
	
	if (!fhan) return -1.0;
	fscanf (fhan, "%d", &rx);
	fclose (fhan);
	
	switch (connect_iface)
	{
	case PPP0:
		fhan = fopen ("/sys/class/net/ppp0/statistics/rx_bytes", "r");
		break;
	case ETH0:
		fhan = fopen ("/sys/class/net/eth0/statistics/rx_bytes", "r");
		break;
	}
	
	if (!fhan) return -1.0;
	fscanf (fhan, "%d", &tx);
	fclose (fhan);
	
	/* once a second */
	d = rx + tx - rxtx;
	rxtx = rx + tx;
	
	g_print ("%s: total = %d delta = %d\n", __FUNCTION__, rxtx, d);
	return (gdouble) d/2000.0;
}

gboolean net_status (gpointer data)
{
	gdouble speed;
	char sspeed [20];
	
	speed = disp_speed ();
	
	if (speed < 0)
	{
		snprintf (sspeed, 20, "***", speed);
//		gtk_widget_show (lookup_widget (windowTop, "ampel_rot"));
//		gtk_widget_hide (lookup_widget (windowTop, "ampel_gruen"));
	}
	else
	{
		snprintf (sspeed, 20, "%7.2f kb/s", speed);
//		gtk_widget_show (lookup_widget (windowTop, "ampel_gruen"));
//		gtk_widget_hide (lookup_widget (windowTop, "ampel_rot"));
	}
	
	gtk_label_set_text (GTK_LABEL (lookup_widget (GTK_WIDGET (data), 
						      "label_speed")), 
			    sspeed);
	
	return TRUE;
}

void report_focus_event (AtkObject *aobject)
{
	if (ATK_IS_EDITABLE_TEXT (aobject))
	{
		tastatur.ref = aobject;
		if (!URI_scrolled) show_tastatur (windowTop);
		else g_signal_emit_by_name (lookup_widget (windowTop,
							   "combo_entry_URI_entry"),
					    "activate");
	}
	else
	    g_print ("children: %d\n",
		     atk_object_get_n_accessible_children (aobject));
}

void parse_rc_entry (xmlDocPtr rc, xmlNodePtr parent, GtkEntry *entry) 
{
	xmlChar *key;
	xmlNodePtr cur;
	
	cur = parent->xmlChildrenNode;
	while (cur != NULL) 
	{
		if ((!xmlStrcmp (cur->name, (const xmlChar *) "value"))) 
		{
			key = xmlNodeListGetString (rc, cur->xmlChildrenNode, 1);
			if (key) 
			{
				g_print ("%s = %s\n", parent->name, key);
				gtk_entry_set_text (entry, key);
			}
			
			xmlFree (key);
		}
		
		cur = cur->next;
	}
	
	return;
}

void parse_rc (char *rc_filename)
{
	xmlDocPtr rc;
	xmlNodePtr cur;
	
	rc = xmlParseFile (rc_filename);
	
	if (rc == NULL ) 
	{
		g_print ("rc-file <%s> could not parsed successfully.\n", 
			 rc_filename);
		return;
	}
	
	cur = xmlDocGetRootElement (rc);
	
	if (cur == NULL) 
	{
		g_print ("empty rc-file.\n");
		xmlFreeDoc (rc);
		return;
	}
	
	if (xmlStrcmp (cur->name, (const xmlChar *) "penguzilla")) 
	{
		g_print ("rc-file of the wrong type\n");
		xmlFreeDoc (rc);
		return;
	}
	
	cur = cur->xmlChildrenNode;
	while (cur != NULL) 
	{
		if ((!xmlStrncmp (cur->name, 
				  (const xmlChar *) "entry_setup", 11)))
		{
			parse_rc_entry (rc, cur, 
					GTK_ENTRY (lookup_widget (windowTop, 
								  cur->name)));
		}
		
		cur = cur->next;
	}
	
	xmlFreeDoc (rc);
}

void save_rc (char *rc_filename, GtkWidget *widget)
{
	int	i;
	FILE	*fhan;
	
	fhan = fopen (rc_filename, "w");
	
	if (!fhan) return;
	
	fprintf (fhan, "<penguzilla>\n");
	for (i = 0; settings [i]; i++)
		fprintf (fhan, "<%s>\n<value>%s</value>\n</%s>\n", settings [i],
			 gtk_entry_get_text (GTK_ENTRY (lookup_widget (widget, 
								       settings [i]))),
			 settings [i]);
	fprintf (fhan, "</penguzilla>\n");
	
	fclose (fhan);
}

int
main (int argc, char *argv[])
{
	gboolean reg;
	gint 		i, j, n_desktops, n_apps;
	gchar 		*s, *URI;
	AtkObject 	*obj;
	char 		*tb_all, *dev_width, *do_fake;
	GtkTreeIter	iter;
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkTreeSelection *select;
		
	keyboard1 = TRUE;
	load_uri = FALSE;
	toolbar_load = FALSE;
	URI_scrolled = FALSE;
	
	gtk_set_locale ();
	gtk_init (&argc, &argv);
	
	device_file_name = getenv ("IDRIVE_NAMED_PIPE");
	dev_width = getenv ("PENGUDRIVE_WIDTH");
	tb_all = getenv ("PENGUTOOLBAR");
	do_fake = getenv ("NOGPRS");
	
	if (tb_all && atof (tb_all)) toolbar_all = TRUE;
	else toolbar_all = FALSE;
	if (dev_width && atof (dev_width)) device_width = atof (dev_width);
	else device_width = 15;
	if (do_fake && atof (do_fake)) nogprs = TRUE;
	else nogprs = FALSE;
	
	gtk_rc_parse ("/usr/share/penguzilla/penguzilla.rc");
	focus_listener = atk_add_focus_tracker (report_focus_event);
	
	obj = atk_get_root ();
	if (!obj) g_error ("Cannot access Accessibility Interface\n");
	
	add_pixmap_directory ("/pixmaps");
	add_pixmap_directory ("/usr/share/penguzilla/pixmaps");
	/*
	 * The following code was added by Glade to create one of each component
	 * (except popup menus), just so that you see something after building
	 * the project. Delete any components that you don't want shown initially.
	 */
	
	windowTop = create_windowTop ();
	parse_rc (PENGUZILLA_SETTINGS);
	
	if (!nogprs) system ("/etc/init.d/ppp-daemon start");
	
	URI = gtk_entry_get_text (GTK_ENTRY (lookup_widget (windowTop, 
							    "entry_setup_url")));
	if (!URI) URI = "http://www.bmw.de";
	
	URI_history = g_list_append (NULL, URI);
	combo_list = create_combo_list ();
	
	gtk_widget_hide (lookup_widget (windowTop, "eventbox_tastatur"));
	gtk_widget_hide (lookup_widget (windowTop, "eventbox_tastatur1"));
	gtk_widget_hide (lookup_widget (windowTop, "progressbar1"));
	gtk_widget_hide (lookup_widget (windowTop, "eventbox_setup"));
	gtk_widget_hide (lookup_widget (windowTop, "ampel_gelb"));
	gtk_widget_hide (lookup_widget (windowTop, "ampel_gruen"));
	gtk_widget_hide (lookup_widget (windowTop, "label_tastatur_dummy"));
	gtk_widget_hide (lookup_widget (windowTop, "label_tastatur1_dummy"));
	gtk_widget_set_usize (lookup_widget (windowTop, "gecko"), 800, 1000);
	gtk_widget_show (windowTop);
	tastatur.active = lookup_widget (windowTop, "tast_a");
	tastatur.prev = NULL;
	tastatur.next = lookup_widget (windowTop, "tast_b");
	tastatur.fix_mouse = FALSE;
	toolbar.active = lookup_widget (windowTop, "setup");
	toolbar.prev = NULL;
	toolbar.next = lookup_widget (windowTop, "online");
	connect_iface = PPP0;
	
	g_timeout_add (2000, net_status, windowTop);
	gtk_set_mouse_position (windowTop, 320, 2);
	
	URIlabel [0] = lookup_widget (combo_list, "labelURI1");
	URIlabel [1] = lookup_widget (combo_list, "labelURI2");
	URIlabel [2] = lookup_widget (combo_list, "labelURI3");
	URIlabel [3] = lookup_widget (combo_list, "labelURI4");
	URIlabel [4] = lookup_widget (combo_list, "labelURI5");
	URIlabel [5] = lookup_widget (combo_list, "labelURI6");
	URIlabel [6] = lookup_widget (combo_list, "labelURI7");
	URIlabel [7] = lookup_widget (combo_list, "labelURI8");
	URIlabel [8] = lookup_widget (combo_list, "labelURI9");
	URIlabel [9] = lookup_widget (combo_list, "labelURI10");

	if (!device_file_name || !device_width)
	{
		g_message ("device_file_name || dev_width not set\n");
		fhan = NULL;
	}
	else fhan = fopen (device_file_name, "w");
	
//	gdk_set_show_events (TRUE);
	gtk_main ();
	return 0;
}
